.TH "mca_coll_sm_component_t" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
mca_coll_sm_component_t \- Structure to hold the sm coll component.  

.PP
.SH SYNOPSIS
.br
.PP
\fC#include <coll_sm.h>\fP
.PP
.SS "Data Fields"

.in +1c
.ti -1c
.RI "mca_coll_base_component_1_0_0_t \fBsuper\fP"
.br
.RI "\fIBase coll component. \fP"
.ti -1c
.RI "int \fBsm_priority\fP"
.br
.RI "\fIMCA parameter: Priority of this component. \fP"
.ti -1c
.RI "int \fBsm_control_size\fP"
.br
.RI "\fIMCA parameter: Length of a cache line or page (in bytes). \fP"
.ti -1c
.RI "char * \fBsm_bootstrap_filename\fP"
.br
.RI "\fIMCA parameter: Name of shared memory control / bootstrap mmap file. \fP"
.ti -1c
.RI "int \fBsm_bootstrap_num_segments\fP"
.br
.RI "\fIMCA parameter: Number of segments in the bootstrap file (for use with setting up multiple comm's with sm components simultaneously). \fP"
.ti -1c
.RI "char * \fBsm_mpool_name\fP"
.br
.RI "\fIMCA parameter: Name of the mpool that this component will use. \fP"
.ti -1c
.RI "int \fBsm_comm_num_in_use_flags\fP"
.br
.RI "\fIMCA parameter: Number of 'in use' flags in each communicator's area in the data mpool. \fP"
.ti -1c
.RI "int \fBsm_comm_num_segments\fP"
.br
.RI "\fIMCA parameter: Number of segments for each communicator in the data mpool. \fP"
.ti -1c
.RI "int \fBsm_fragment_size\fP"
.br
.RI "\fIMCA parameter: Fragment size for data. \fP"
.ti -1c
.RI "int \fBsm_tree_degree\fP"
.br
.RI "\fIMCA parameter: Degree of tree for tree-based collectives. \fP"
.ti -1c
.RI "int \fBsm_info_comm_size\fP"
.br
.RI "\fIMCA parameter: Number of processes to use in the calculation of the 'info' MCA parameter. \fP"
.ti -1c
.RI "size_t \fBsm_bootstrap_size\fP"
.br
.RI "\fISize of the bootstrap area -- calculated in \fBcoll_sm_component.c\fP. \fP"
.ti -1c
.RI "size_t \fBsm_data_mpool_size\fP"
.br
.RI "\fISize of the data mpool area -- calculated in \fBcoll_sm_component.c\fP. \fP"
.ti -1c
.RI "\fBmca_mpool_base_module_t\fP * \fBsm_data_mpool\fP"
.br
.RI "\fIData mpool that will be used. \fP"
.ti -1c
.RI "bool \fBsm_data_mpool_created\fP"
.br
.RI "\fIWhether we ended up creating the sm mpool or whether someone else created it and we just found it. \fP"
.ti -1c
.RI "mca_common_sm_mmap_t * \fBsm_bootstrap_meta\fP"
.br
.RI "\fIMeta struct containing information about the bootstrap area. \fP"
.ti -1c
.RI "int \fBsm_segs_per_inuse_flag\fP"
.br
.RI "\fIHow many fragment segments are protected by a single in-use flags. \fP"
.ti -1c
.RI "bool \fBsm_component_setup\fP"
.br
.RI "\fIWhether the component's shared memory has been [lazily] initialized or not. \fP"
.ti -1c
.RI "bool \fBsm_component_setup_success\fP"
.br
.RI "\fIOnce the component has been lazily initialized, keep the state of it around. \fP"
.ti -1c
.RI "\fBopal_atomic_lock_t\fP \fBsm_component_setup_lock\fP"
.br
.RI "\fIA lock protecting the lazy initialzation of the component (SINCE THERE IS NO STATIC INITIALIZER FOR \fBopal_atomic_lock_t\fP, THIS *MUST* BE THE LAST MEMBER OF THE STRUCT!). \fP"
.in -1c
.SH "Detailed Description"
.PP 
Structure to hold the sm coll component. 

First it holds the base coll component, and then holds a bunch of sm-coll-component-specific stuff (e.g., current MCA param values). 
.PP
.SH "Field Documentation"
.PP 
.SS "int \fBmca_coll_sm_component_t::sm_segs_per_inuse_flag\fP"
.PP
How many fragment segments are protected by a single in-use flags. 
.PP
This is solely so that we can only perform the division once and then just use the value without having to re-calculate. 

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
